#include <iostream>

using namespace std;

#define MAX_N 1000000

int cifre[MAX_N];

int main()
{
    int N;
    scanf("%d", &N);

    int poslednjePojavljivanje[10];
    for(int i = 0; i < 10; i++){
        poslednjePojavljivanje[i] = -1;
    }

    for(int i = 0; i < N; i++){
        scanf("%d", cifre + i);
        poslednjePojavljivanje[cifre[i]] = i;
    }
    bool zamenjen;
    for(int i = 0; i < N; i++){

        for(int j = 9; j > cifre[i]; j--){
            if(poslednjePojavljivanje[j] > i){
                int temp = cifre[poslednjePojavljivanje[j]];
                zamenjen = true;
                cifre[poslednjePojavljivanje[j]] = cifre[i];
                cifre[i] = temp;
                break;
            }
        }

        if(zamenjen){
            break;
        }

    }

    if(!zamenjen){
        int temp = cifre[N - 1];
        cifre[N - 1] = cifre[N - 2];
        cifre[N - 2] = temp;
    }


    for(int i = 0; i < N; i++){
        printf("%d ", cifre[i]);
    }

    return 0;
}